Index: WAeUP_SRP/base/WAeUPTool.py
===================================================================
--- WAeUP_SRP/base/WAeUPTool.py	(revision 3171)
+++ WAeUP_SRP/base/WAeUPTool.py	(revision 3172)
@@ -1335,706 +1339,241 @@
     ###)
 
-    security.declareProtected(ModifyPortalContent,'mass_create_faculty') ###(
-    def mass_create_faculty(self,mapping):
-        "create a faculty"
-        logger = logging.getLogger('WAeUPTool.mass_create_faculty')
-        academics_folder = self.portal_url.getPortalObject().campus.academics
-        fid = mapping['code']
-        if getattr(academics_folder,fid,None) is not None:
-            return '', "Faculty with ID: %s exists" % fid
-        logger.info('Creating Faculty %(code)s, %(title)s' % mapping)
-        try:
-            academics_folder.invokeFactory('Faculty', fid)
-        except BadRequest,E:
-            return '', "%s" % E
-        f = getattr(academics_folder,fid,None)
-        f.getContent().edit(mapping=mapping)
-        return fid,''
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_edit_faculty') ###(
-    def mass_edit_faculty(self,mapping):
-        "edit a faculty"
-        logger = logging.getLogger('WAeUPTool.mass_edit_faculty')
-        academics_folder = self.portal_url.getPortalObject().campus.academics
-        fid = mapping['code']
-        f = getattr(academics_folder,fid,None)
-        if f is None:
-            return '', "Faculty with ID: %s does not exist" % fid
-        logger.info('Editing Faculty %(code)s, %(title)s' % mapping)
-        f.getContent().edit(mapping=mapping)
-        return fid,''
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_create_department') ###(
-    def mass_create_department(self,mapping):
-        "create a department in the correct faculty"
-        logger = logging.getLogger('WAeUPTool.mass_create_department')
-        fid = mapping['faculty_code']
-        if getattr(self,'_v_faculties',None) is None:
-            res = self.portal_catalog(portal_type = "Faculty")
-            self._v_faculties = {}
-            for f in res:
-                self._v_faculties[f.getId] = f.getObject()
-        f = self._v_faculties.get(fid,None)
-        if f is None:
-            return '', "No Faculty with ID: %s" % fid
-        else:
-            did = mapping.get('code')
-            d = getattr(f,did,None)
-            if d is None or d.portal_type == "Faculty":
-                logger.info('Creating Department %(code)s, %(title)s' % mapping)
-                try:
-                    f.invokeFactory('Department', did)
-                except BadRequest,E:
-                    return '', "%s" % E
-                d = getattr(f,did)
-                d.invokeFactory('CoursesFolder','courses')
-                courses = getattr(d,'courses')
-                dict = {'Title': 'Courses'}
-                courses.getContent().edit(mapping=dict)
-                d.invokeFactory('CertificatesFolder','certificates')
-                certificates = getattr(d,'certificates')
-                dict = {'Title': 'Certificates'}
-                certificates.getContent().edit(mapping=dict)
-            d.getContent().edit(mapping=mapping)
-        return did,''
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_edit_department') ###(
-    def mass_edit_department(self,mapping):
-        "create a department in the correct faculty"
-        logger = logging.getLogger('WAeUPTool.mass_create_department')
-        academics_folder = self.portal_url.getPortalObject().campus.academics
-        fid = mapping['faculty_code']
-        did = mapping.get('code')
-        try:
-            d = getattr(getattr(academics_folder,fid),did,None)
-        except KeyError:
-            return '', "Department %s or Faculty %s wrong" % (did,fid)
-        else:
-            if d is None or d.portal_type == "Faculty":
-                logger.info('Editing Department %(code)s, %(title)s' % mapping)
-            d.getContent().edit(mapping=mapping)
-        return did,''
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_create_course') ###(
-    def mass_create_course(self,mapping):
-        #import pdb;pdb.set_trace()
-        if getattr(self,'_v_course_list',None) is None:
-            self._v_course_list = []
-        if getattr(self,'_v_departments',None) is None:
-            res = self.portal_catalog(portal_type = "Department")
-            self._v_department_courses = {}
-            for d in res:
-                self._v_department_courses[d.getId] = getattr(d.getObject(),"courses",None)
-        did = mapping['department_code']
-        d = self._v_department_courses.get(did,None)
-        if d is None:
-            return '', "No Department with ID: %s" % did
-        course_id = mapping.get('code')
-        if course_id in self._v_course_list:
-            return '', "Duplicate Course ID: %s" % did
-        c = getattr(d,course_id,None)
-        if c is not None:
-            return '', "Duplicate Course ID: %s" % did
-        try:
-            d.invokeFactory('Course', course_id)
-        except BadRequest,E:
-            return '', "%s" % E
-        self._v_course_list.append(course_id)
-        c = getattr(d,course_id)
-        c.getContent().edit(mapping=mapping)
-        return course_id,''
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_edit_course') ###(
-    def mass_edit_course(self,mapping):
-        #import pdb;pdb.set_trace()
-        course_id = mapping.get('code')
-        res = self.portal_catalog(id=course_id)
-        if not res:
-            return '', "No Course with ID: %s" % course_id
-        c = res[0].getObject()
-        c.getContent().edit(mapping=mapping)
-        return course_id,''
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_create_certificate') ###(
-    def mass_create_certificate(self,mapping):
-        if getattr(self,'_v_certificate_list',None) is None:
-            self._v_certificate_list = []
-        if getattr(self,'_v_department_certificates',None) is None:
-            res = self.portal_catalog(portal_type = "Department")
-            self._v_department_certificates = {}
-            for d in res:
-                self._v_department_certificates[d.getId] = getattr(d.getObject(),"certificates",None)
-        did = mapping['department_code']
-        d = self._v_department_certificates.get(did,None)
-        if d is None:
-            return '', "No Department with ID: %s" % did
-        certificate_id = mapping.get('code')
-        if certificate_id in self._v_certificate_list:
-            return '', "Duplicate Certificate ID: %s" % did
-        c = getattr(d,certificate_id,None)
-        if c is not None:
-            return '', "Duplicate Certificate ID: %s" % did
-        try:
-            d.invokeFactory('Certificate', certificate_id)
-        except BadRequest,E:
-            return '', "%s" % E
-        self._v_certificate_list.append(certificate_id)
-        c = getattr(d,certificate_id)
-        c.getContent().edit(mapping=mapping)
-        return certificate_id,''
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_edit_certificate') ###(
-    def mass_edit_certificate(self,mapping):
-        #import pdb;pdb.set_trace()
-        certificate_id = mapping.get('code')
-        res = self.portal_catalog(id=certificate_id)
-        if not res:
-            return '', "No Certificate with ID: %s" % certificate_id
-        c = res[0].getObject()
-        c.getContent().edit(mapping=mapping)
-        return certificate_id,''
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_create_application') ###(
-    def mass_create_application(self,mapping):
-        #import pdb;pdb.set_trace()
-        reg_no = mapping.get('reg_no')
-        try:
-            self.applicants_catalog.addRecord(**mapping)
-        except ValueError:
-            return '', "applicant record with reg_no %s already exists" % reg_no
-        return reg_no,''
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_edit_application') ###(
-    def mass_edit_application(self,mapping):
-        #import pdb;pdb.set_trace()
-        reg_no = mapping.get('reg_no')
-        status = mapping.get('status')
-        res = self.applicants_catalog(reg_no = reg_no)
-        if len(res):
-            if res[0].status == 'created' and status != 'created':
-                return '', "student object with id %s for %s already created, status cannot be changed" % (res[0].student_id, reg_no)
-            elif status == 'created' and res[0].status != 'created':
-                return '', "student object for %s has not yet been created, status cannot be set to 'created'" % (reg_no)
-            else:
-                self.applicants_catalog.modifyRecord(**mapping)
-                return reg_no,''
-        else:
-            return '', "applicant record with reg_no %s does not exist" % reg_no
-
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_create_course_result') ###(
-    def mass_create_course_result(self,mapping):
-        #import pdb;pdb.set_trace()
-        students_folder = self.portal_url.getPortalObject().campus.students
-        if getattr(self,'_v_courses',None) is None:
-            res = self.courses_catalog()
-            self._v_courses = {}
-            for brain in res:
-                self._v_courses[brain.code] = brain
-        if getattr(self,'_v_level_created',None) is None:
-            self._v_level_created = []
-        course_id = mapping.get('code')
-        if course_id not in self._v_courses.keys():
-            return '', "No course with ID: %s" % course_id
-        id_key = ''
-        for id_key in ('student_id','matric_no'):
-            id_field = mapping.get(id_key,None)
-            if id_field is not None:
-                student_id = id_field
-                break
-        query = Eq(id_key,id_field)
-        res = self.students_catalog.evalAdvancedQuery(query)
-        if not res:
-            return '', "no student with %(id_key)s %(id_field)s" % vars()
-        student_rec = res[0]
-        if id_field != "student_id":
-            mapping['student_id'] = student_rec.id
-        student_id = student_rec.id
-        level_id = mapping['level_id']
-        code = mapping['code']
-        if student_id not in self._v_level_created:
-            try:
-                context = getattr(getattr(students_folder,
-                                          "%(student_id)s" % vars()),
-                                  'study_course')
-            except:
-                return '', "could not create level %(level_id)s for %(student_id)s" % vars()
-            if level_id not in context.objectIds():
-                context.invokeFactory('StudentStudyLevel',"%(level_id)s" % vars())
-                level = getattr(context,"%(level_id)s" % vars())
-                self.portal_workflow.doActionFor(level,'open')
-                # the session string must not be copied into the level object
-                current_verdict = getattr(student_rec,'current_verdict','')
-                current_session = getattr(student_rec,'current_session','')
-                if current_verdict and student_rec.current_level == level_id:
-                    level.getContent().edit(mapping={'verdict': "%s" %
-                                                     current_verdict,
-                                                     'session': "%s" %
-                                                     current_session,
-                                                    })
-                    self.portal_workflow.doActionFor(level,'close')
-            self._v_level_created += student_id,
-        mapping['key'] = key = "%(student_id)s|%(level_id)s|%(code)s" % vars()
-        for k in ('semester','credits',):
-            mapping[k] = getattr(self._v_courses[course_id],k)
-        try:
-            self.course_results.addRecord(**mapping)
-        except ValueError:
-            return '', "course result already exists: %s" % key
-        return key,''
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_edit_course_result') ###(
-    def mass_edit_course_result(self,mapping):
-        #import pdb;pdb.set_trace()
-        while True:
-            result_id = mapping.get('id',None)
-            if result_id is not None:
-                mapping['key'] = key = result_id
-                break
-            for id_key in ('student_id','matric_no'):
-                id_field = mapping.get(id_key,None)
-                if id_field is not None:
-                    student_id = id_field
-                    break
-            query = Eq(id_key,id_field)
-            res = self.students_catalog.evalAdvancedQuery(query)
-            if not res:
-                return '', "No student with %(id_key)s %(id_field)s" % vars()
-            if id_field == "matric_no":
-                mapping['student_id'] = res[0].id
-            elif id_field == "student_id":
-                mapping['matric_no'] = res[0].matric_no
-            if not res:
-                return '', "No student with %(id_key)s %(id_field)s" % vars()
-            student_rec = res[0]
-            student_id = student_rec.id
-            level_id = mapping['level_id']
-            code = mapping['code']
-            mapping['key'] = key = "%(student_id)s|%(level_id)s|%(code)s" % vars()
-            break
-        try:
-            self.course_results.modifyRecord(**mapping)
-        except KeyError:
-            return key, "No course result to edit: %s" % key,mapping
-        return key,''
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_delete_course_result') ###(
-    def mass_delete_course_result(self,mapping):
-        id_key = ''
-        for id_key in ('student_id','matric_no'):
-            id_field = mapping.get(id_key,None)
-            if id_field is not None:
-                student_id = id_field
-                break
-        query = Eq(id_key,id_field)
-        res = self.students_catalog.evalAdvancedQuery(query)
-        if not res:
-            return '', "No student with %(id_field)s: %(id_key)s" % vars()
-        if id_field != "student_id":
-            mapping['student_id'] = res[0].id
-        if not res:
-            return '', "no student with %(id_key)s %(id_field)s" % vars()
-        student_rec = res[0]
-        student_id = student_rec.id
-        level_id = mapping['level_id']
-        code = mapping['code']
-        key = "%(student_id)s|%(level_id)s|%(code)s" % vars()
-        # for k in ('semester',):
-        #     mapping[k] = getattr(self._v_courses[course_id],k)
-        if self.course_results.getRecordByKey(key) is None:
-            return '', "no course-result with %(key)s" % vars()
-        self.course_results.deleteRecord(key)
-        return key,''
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_create_certificate_course') ###(
-    def mass_create_certificate_course(self,mapping):
-        if getattr(self,'_v_courses',None) is None:
-            res = self.courses_catalog()
-            self._v_courses= [course.code for course in res]
-        if getattr(self,'_v_ceritficates',None) is None:
-            res = self.portal_catalog(portal_type = "Certificate")
-            self._v_certificates = {}
-            for cert in res:
-                self._v_certificates[cert.getId] = cert.getObject()
-        certificate_course_id = mapping.get('code')
-        if certificate_course_id not in self._v_courses:
-            return '', "No Course with ID: %s" % certificate_course_id
-        cert_id = mapping['certificate_code']
-        cert = self._v_certificates.get(cert_id,None)
-        if cert is None:
-            return '', "No Certificate with ID: %s" % cert_id
-        level_id = mapping.get('level')
-        level = getattr(cert,level_id,None)
-        if level is None:
-            cert.invokeFactory('StudyLevel', level_id)
-            level = getattr(cert,level_id,None)
-        elif hasattr(level,certificate_course_id):
-            return '', "Duplicate CertificateCourse ID: %s in %s/ %s" %\
-            (certificate_course_id,cert_id,level_id)
-        level.invokeFactory('CertificateCourse', certificate_course_id)
-        c = getattr(level,certificate_course_id)
-        c.getContent().edit(mapping=mapping)
-        return certificate_course_id,''
-    ###)
-
-    field2types_student = {   ###(
-                      'StudentApplication':
-                          {'id': 'application',
-                           'title': 'Application Data',
-                           'wf_transition_return': 'close',
-                           'wf_transition_admit': 'remain',
-                           'fields':
-                             ('jamb_reg_no',
-                              'entry_mode',
-                              'entry_session',
-                              'jamb_score',
-                              'app_email',
-                              'jamb_age',
-                              'jamb_state',
-                              'jamb_lga',
-                              'jamb_sex',
-                              )
-                              },
-                      #'StudentPume':
-                      #    {'id': 'pume',
-                      #     'title': 'Pume Data',
-                      #     'wf_transition_return': 'close',
-                      #     'wf_transition_admit': 'close',
-                      #     'fields':
-                      #       ('pume_score',
-                      #        )
-                      #        },
-                      'StudentClearance':
-                          {'id': 'clearance',
-                           'title': 'Clearance/Eligibility Record',
-                           'wf_transition_return': 'close',
-                           'wf_transition_admit': 'remain',
-                           'fields':
-                             ('matric_no',
-                              'nationality',
-                              'lga',
-                              'birthday',
-                              )
-                              },
-                         'StudentPersonal':
-                          {'id': 'personal',
-                           'title': 'Personal Data',
-                           'wf_transition_return': 'open',
-                           'wf_transition_admit': 'remain',
-                           'fields':
-                             ('firstname',
-                              'middlename',
-                              'lastname',
-                              'sex',
-                              'email',
-                              'phone',
-                              'perm_address',
-                              )
-                              },
-                         'StudentStudyCourse':
-                          {'id': 'study_course',
-                           'title': 'Study Course',
-                           'wf_transition_return': 'open',
-                           'wf_transition_admit': 'remain',
-                           'fields':
-                             ('study_course',
-                              'current_level',
-                              'current_session',
-                              'current_mode',
-                              'current_verdict',
-                              'previous_verdict',
-                              )
-                              },
-                         # 'StudentStudyLevel':
-                         #  {'id': 'current_level',
-                         #   'title': '',
-                         #   'wf_transition_return': 'open',
-                         #   'wf_transition_admit': 'remain',
-                         #   'fields':
-                         #     ('verdict',
-                         #      'session',
-                         #      )
-                         #      },
-                         'PaymentsFolder':
-                          {'id': 'payments',
-                           'title': 'Payments',
-                           'wf_transition_return': 'open',
-                           'wf_transition_admit': 'open',
-                           'fields':
-                             ()
-                              },
-                         }
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_create_student') ###(
-    def mass_create_student(self,mapping):
-        "create student records due import"
-        logger = logging.getLogger('WAeUPTool.mass_create_student')
-        students_folder = self.portal_url.getPortalObject().campus.students
-        jamb_reg_no = mapping.get('jamb_reg_no',None)
-        if jamb_reg_no:
-            res = self.students_catalog(jamb_reg_no = jamb_reg_no)
-            if res:
-                return '',"jamb_reg_no exists"
-        matric_no = mapping.get('matric_no',None)
-        if matric_no:
-            res = self.students_catalog(matric_no = matric_no)
-            if res:
-                return '',"matric_no exists"
-        sid = self.waeup_tool.generateStudentId('?')
-        students_folder.invokeFactory('Student', sid)
-        student_obj = getattr(students_folder,sid)
-        f2t = self.field2types_student
-        d = {}
-        transition = mapping.get('reg_transition','admit')
-        if transition not in ('admit','return'):
-            return '',"no valid transition provided"
-        for pt in f2t.keys():
-            student_obj.invokeFactory(pt,f2t[pt]['id'])
-            sub_obj = getattr(student_obj,f2t[pt]['id'])
-            sub_doc = sub_obj.getContent()
-            d['Title'] = f2t[pt]['title']
-            for field in f2t[pt]['fields']:
-                d[field] = mapping.get(field,'')
-
-            if pt == "StudentApplication":
-                #d['jamb_sex']  = 'M'
-                #if mapping.get('sex'):
-                #    d['jamb_sex']  = 'F'
-                d['jamb_firstname'] = mapping.get('firstname',None)
-                d['jamb_middlename'] = mapping.get('middlename',None)
-                d['jamb_lastname'] = mapping.get('lastname',None)
-
-            # if pt == "StudyCourse":
-            #     for von,zu in (('entry_mode','current_mode'),
-            #                    ('entry_session','current_session')):
-            #         if mapping.get(zu,None) is None and mapping.get(von,None) is not None:
-            #             d[zu] = mapping[von]
-            sub_doc.edit(mapping = d)
-
-            #import pdb;pdb.set_trace()
-            new_state = f2t[pt]['wf_transition_%(transition)s' % vars()]
-            if new_state != "remain":
-                self.portal_workflow.doActionFor(sub_obj,new_state,dest_container=sub_obj)
-        self.portal_workflow.doActionFor(student_obj,transition)
-        student_obj.manage_setLocalRoles(sid, ['Owner',])
-        return sid,''
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_edit_student') ###(
-    def mass_edit_student(self,mapping):
-        wftool = self.portal_workflow
-        "edit student records due import"
-        logger = logging.getLogger('WAeUPTool.mass_edit_student')
-        students_folder = self.portal_url.getPortalObject().campus.students
-        sid = mapping.get('id',None)
-        jamb_reg_no = mapping.get('jamb_reg_no',None)
-        matric_no = mapping.get('matric_no',None)
-        editable_keys = mapping.keys()
-        if sid:
-            res = self.students_catalog(id = sid)
-            if not res:
-                return '',"no student with id %s" % sid
-            if matric_no and res[0].matric_no and\
-              matric_no != res[0].matric_no:
-                logger.info("%s, old matric_no %s overwritten with %s" % (res[0].id,res[0].matric_no,matric_no))
-            if jamb_reg_no and res[0].jamb_reg_no and\
-              jamb_reg_no != res[0].jamb_reg_no:
-                logger.info("%s, old reg_no %s overwritten with %s" % (res[0].id,res[0].jamb_reg_no,jamb_reg_no))
-        elif jamb_reg_no:
-            res = self.students_catalog(jamb_reg_no = jamb_reg_no)
-            if not res:
-                return '',"no student with jamb_reg_no %s" % jamb_reg_no
-            editable_keys.remove('jamb_reg_no')
-        elif matric_no:
-            res = self.students_catalog(matric_no = matric_no)
-            if not res:
-                return '',"no student with matric_no %s" % matric_no
-            editable_keys.remove('matric_no')
-
-        ## included only to change wf state from admitted to returning
-        #if res[0].review_state not in ('admitted','objection_raised'):
-        #    return '%s' % res[0].id ,"student is not in state admitted or objection_raised"
-        ## end inclusion
-
-        sid = res[0].id
-        student_obj = getattr(students_folder,sid)
-        f2t = self.field2types_student
-        d = {}
-        #import pdb;pdb.set_trace()
-        any_change = False
-        #special treatment for StudentStudyLevel
-        d['verdict']  = mapping.get('current_verdict','')
-        d['session']  = mapping.get('current_session','')
-        current_level = mapping.get('current_level','')
-        while d['session'] and d['verdict'] and current_level:
-            sub_obj = getattr(student_obj,'study_course',None)
-            if sub_obj is None:
-                break
-            level_obj = getattr(sub_obj,current_level,None)
-            if  level_obj is None:
-                break
-            any_change = True
-            level_obj.getContent().edit(mapping = d)
-            try:
-                wftool.doActionFor(level_obj,'close')
-            except:
-                pass
-            break
-        for pt in f2t.keys():
-            #if pt == "StudentApplication":
-            #    d['jamb_sex']  = 'M'
-            #    if mapping.get('sex'):
-            #        d['jamb_sex']  = 'F'
-            intersect = set(f2t[pt]['fields']).intersection(set(editable_keys))
-            if intersect and pt not in ('StudentStudyLevel',):
-                object_id = f2t[pt]['id']
-                sub_obj = getattr(student_obj,object_id,None)
-                if sub_obj is None:
-                    try:
-                        student_obj.invokeFactory(pt,object_id)
-                    except:
-                        continue
-                    sub_obj = getattr(student_obj,object_id)
-                    if f2t[pt]['title'] != '':
-                        d['Title'] = f2t[pt]['title']
-                sub_doc = sub_obj.getContent()
-                for field in intersect:
-                    changed = False
-                    if getattr(sub_doc,field,None) != mapping.get(field,''):
-                        any_change = True
-                        changed = True
-                        d[field] = mapping.get(field,'')
-                    if changed:
-                        sub_doc.edit(mapping = d)
-
-
-        ## included only to change wf state from admitted to returning
-        #    if res[0].review_state in ('admitted','objection_raised'):
-        #        new_state = f2t[pt]['wf_transition_return']
-        #        sub_obj = getattr(student_obj,f2t[pt]['id'],None)
-        #        if sub_obj and new_state != "remain":
-        #            try:
-        #                self.portal_workflow.doActionFor(sub_obj,new_state,dest_container=sub_obj)
-        #            except:
-        #                #logger.info('%s, wf transition %s of %s failed' % (sid,new_state,sub_obj.id))
-        #                pass
-        #if res[0].review_state in ('admitted','objection_raised'):
-        #    wfaction = 'return'
-        #    try:
-        #        self.portal_workflow.doActionFor(student_obj,wfaction)
-        #        logger.info('%s, wf state changed' % sid)
-        #        any_change = True
-        #    except:
-        #        logger.info('%s, wf transition failed, old state = %s' % (sid,res[0].review_state))
-        #        pass
-        ## end inclusion
-
-
-        if any_change:
-            return sid,''
-        else:
-            return sid,'not modified'
-    ###)
-
-    security.declareProtected(ModifyPortalContent,'mass_edit_verdict') ###(
-    def mass_edit_verdict(self,mapping):
-        wftool = self.portal_workflow
-        "edit student verdicts"
-        logger = logging.getLogger('WAeUPTool.mass_edit_verdict')
-        students_folder = self.portal_url.getPortalObject().campus.students
-        student_id = mapping.get('id',None)
-        matric_no = mapping.get('matric_no',None)
-        editable_keys = mapping.keys()
-        if student_id:
-            student_record = self.students_catalog.getRecordByKey(student_id)
-            if student_record is None:
-                return '',"no student with id %s" % student_id
-            if matric_no and student_record.matric_no and\
-              matric_no != student_record.matric_no:
-                return '', 'student %s: matric_no %s does not match %s' % (student_record.id,
-                                                                          student_record.matric_no,
-                                                                          matric_no)
-            mapping['matric_no'] = student_record.matric_no
-        elif matric_no:
-            res = self.students_catalog(matric_no = matric_no)
-            if not res:
-                return '',"no student with matric_no %s" % matric_no
-            student_record = res[0]
-            editable_keys.remove('matric_no')
-        else:
-            return '',"no id or matric_no specified"
-        student_id = student_record.id
-        d = {}
-        #import pdb;pdb.set_trace()
-        any_change = False
-        #special treatment for StudentStudyLevel
-        current_session = d['session'] = mapping.get('current_session','')
-        if current_session and student_record.session != current_session:
-            msg = 'student %s: imported session %s does not match current_session %s' % (student_id,
-                                                                                        current_session,
-                                                                                        student_record.session)
-            return student_id,msg,mapping
-        current_level = mapping.get('current_level','')
-        if not current_level.isdigit():
-            return '','student %s: imported level is empty' % (student_id,)
-        if current_level and student_record.level != current_level:
-            msg = 'student %s: imported level %s does not match current_level %s' % (student_id,
-                                                                                    current_level,
-                                                                                    student_record.level)
-            return student_id,msg,mapping
-        student_review_state =  student_record.review_state
-        if student_review_state == 'deactivated':
-            return '',"student %s in review_state %s" % (student_id, student_review_state)
-        if student_review_state not in ('courses_validated','returning'):
-            msg = "student %s in wrong review_state %s" % (student_id, student_review_state)
-            return student_id,msg,mapping
-        student_obj = getattr(students_folder,student_id)
-        f2t = self.field2types_student
-        study_course_obj = getattr(student_obj,'study_course',None)
-        if study_course_obj is None:
-            return '','student %s: no study_course object' % student_id
-        level_obj = getattr(study_course_obj,current_level,None)
-        if  level_obj is None:
-            return '','student %s: no study_level object for level %s' % (student_id,
-                                                                             current_level)
-        verdict = d['verdict'] = d['current_verdict']  = mapping.get('current_verdict','')
-
-        #if verdict == student_record.verdict:
-        #    return '','student %s: verdict already set to %s' % (student_id,
-        #                                                            verdict)
-
-        level_review_state = wftool.getInfoFor(level_obj,'review_state',None)
-        if level_review_state != "closed":
-            wftool.doActionFor(level_obj,'close')
-            # return '','student %s: level %s is not closed' % (student_id,
-            #                                                      current_level)
-
-        study_course_obj.getContent().edit(mapping = d)
-        level_obj.getContent().edit(mapping = d)
-        if student_review_state != "returning":
-            wftool.doActionFor(student_obj,'return')
-        # try:
-        #     wftool.doActionFor(level_obj,'close')
-        # except:
-        #     pass
-        return student_id,''
-    ###)
-
     security.declareProtected(ModifyPortalContent,"importData")###(
     def importData(self,filename,name,edit=False,bypass_queue_catalog=False):
+        """load data from CSV values"""
+        import transaction
+        import random
+        students_folder = self.portal_url.getPortalObject().campus.students
+        pending_only = False
+        pend_str = '_pending'
+        elapse = time.time()
+        #
+        # preparations
+        #
+        if name.endswith(pend_str):
+            pending_only = True
+            name = name[:-len(pend_str)]
+        mode = "create"
+        if edit:
+            if filename.endswith('_toDelete'):
+                mode = "delete"
+            else:
+                mode = "edit"
+        # schema = stool._getOb(iname)
+        # if schema is None:
+        #     em = 'No such schema %s' % iname
+        #     logger.error('No such schema %s' % iname)
+        #     return em
+        # pending_schema = stool._getOb("%s_pending" % iname)
+        # if pending_schema is None:
+        #     em = 'No such schema %s_pending' % iname
+        #     logger.error('No such schema %s_pending' % iname)
+        #     return em
+        # layout = ltool._getOb(iname)
+        # if layout is None:
+        #     em = 'No such layout %s' % iname
+        #     logger.error(em)
+        #     return em
+        importer_name = ''.join([part.capitalize() for part in name.split('_')])
+        importer = eval("%sImport" % importer_name)(mode,self)
+        logger = importer.logger
+        if importer.init_errors:
+            logger.info(self.init_errors)
+            return self.init_errors
+        member = importer.member
+        current = importer.current
+        import_date = importer.import_date
+        #
+        # not_imported
+        #
+        info = importer.info
+        data_keys = importer.data_keys
+        csv_keys = importer.csv_keys 
+        #csv_keys.extend(info.keys())
+        headline_mapping = dict((k,k) for k in csv_keys)
+        #
+        # pending
+        #
+        pending_path = importer.pending_path
+        pending_tmp = importer.pending_tmp
+        pending_backup = importer.pending_backup
+        pending_fn = importer.pending_fn
+        imported_path = importer.imported_path
+        imported_fn = importer.imported_fn
+        pending = []
+        pending_digests = []
+        #total_added_to_pending = 0
+        if not pending_only:
+            pending,pending_digests = importer.makeIdLists()
+            pending_at_start = len(pending)
+        datafile = open(pending_tmp,"w")
+        pending_csv_writer = csv.DictWriter(datafile,
+                                                    csv_keys,
+                                                    extrasaction='ignore')
+        pending_csv_writer.writerow(headline_mapping)
+        datafile.close()
+        #
+        # imported
+        #
+        if not os.path.exists(imported_path):
+            datafile = open(imported_path,"w")
+            imported_csv_writer = csv.DictWriter(datafile,
+                                                 csv_keys,
+                                                 extrasaction='ignore')
+            imported_csv_writer.writerow(headline_mapping)
+            datafile.close()
+        start = True
+        tr_count = 0
+        total = 0
+        total_added_to_imported = 0
+        total_pending = 0
+        if pending_only:
+            import_source_path = pending_path
+        else:
+            import_source_path = "%s/import/%s.csv" % (i_home,filename)
+        if not os.path.exists(import_source_path):
+            em = 'No  %(import_source_fn)s' % vars()
+            return em
+        import_source_fn = os.path.split(import_source_path)[1]
+        info['imported_from'] = import_source_fn
+        attrs = csv.reader(open(import_source_path,"rb")).next()
+        import_keys = [k.strip() for k in attrs if not (k.strip().startswith('ignore')
+                                                        or k.strip() in info.keys())]
+        diff2schema = set(import_keys).difference(set(importer.schema.keys()))
+        diff2layout = set(import_keys).difference(set(importer.layout.keys()))
+        if diff2schema and diff2schema != set(['id',]):
+            msg = 'not ignorable key(s): "%s" found in heading' % ", ".join(diff2schema)
+            return msg
+        if mode in importer.required_modes:
+            required_keys = [importer.layout.getIdUnprefixed(id)
+                                for id,widget in importer.layout.objectItems()
+                                if widget.is_required]
+            if not set(required_keys).issubset(set(import_keys)):
+                diff2import = set(required_keys).difference(set(import_keys))
+                msg = 'required key(s): "%s" not found in heading' % ", ".join(diff2import)
+                return msg
+        #
+        # start importing
+        #
+        try:
+            reader = csv.DictReader(open(import_source_path,"rb"))
+        except:
+            msg = 'Error reading %s.csv' % filename
+            logger.error(msg)
+            return msg
+        items = [item for item in reader]
+        total_to_import = len(items)
+        tti_float = float(total_to_import) 
+        if pending_only:
+            pending_at_start = total_to_import
+        count = 0
+        imported = []
+        old_commit_count = 0
+        with_error_count = imported_count = 0
+        already_in = 0
+        for record in items:
+            item = {}
+            for k,v in record.items():
+                if v:
+                    item[k.strip()] = v.strip()
+            count += 1
+            #item = dict((k.strip(),l.strip()) for (k,l) in item.items())
+            if start:
+                start = False
+                adapters = [MappingStorageAdapter(importer.schema, item)]
+                logger.info('%(member)s starts import from %(import_source_fn)s in %(mode)s mode' % vars())
+                #logger.info('%s starts import from %s in %s mode with schema and layout %s' % (member,filename,mode,iname))
+            dm = DataModel(item, adapters,context=self)
+            ds = DataStructure(data=item,datamodel=dm)
+            error_string = ""
+            total += 1
+            for k in import_keys:
+                if k not in item.keys() or k not in importer.validators.keys():
+                    continue
+                if not importer.validators[k](ds,mode=mode):
+                    if error_count:
+                        error_string += ' ++ '
+                    error_string += "%s: %s" % (k,self.translation_service(ds.getError(k),
+                                                                           ds.getErrorMapping(k)))
+                    error_count += 1
+            if error_string:
+                error = error_string
+                id = ''
+                mapping = item
+            else:
+                temp_item = item.copy()
+                temp_item.update(dm)
+                results = importer.import_method(temp_item)
+                id = results[0]
+                error = results[1]
+                mapping = results[2]
+            data_string = ",".join("%s : %s" % (k,v) for k,v in mapping.items())
+            info['error'] = error
+            mapping.update(info)
+            if error:
+                digest = makeDigest(mapping,data_keys)
+                with_error_count += 1
+                percent_finished = (with_error_count + imported_count)/tti_float*100
+                if digest not in pending_digests:
+                    pending_digests += digest,
+                    pending.append(mapping)
+                    if not pending_only:
+                        logger.info("%(percent_finished)6.3f %% done added to %(pending_fn)s %(data_string)s" % vars())
+                else:
+                    already_in += 1
+                    #logger.info("already in %(pending_fn)s %(data_string)s" % vars())
+                    pass
+            else:
+                imported_count += 1
+                imported += mapping,
+                percent_finished = (with_error_count + imported_count)/tti_float*100
+                logger.info("%(percent_finished)6.3f %% done  imported and added to  %(imported_fn)s %(data_string)s" % vars())
+            finished = count > total_to_import - 1
+            must_commit = False
+            if len(imported) != old_commit_count:
+                if not len(imported) % importer.commit_after:
+                    must_commit = True
+                    old_commit_count = len(imported)
+                    
+            if must_commit or finished:
+                if len(imported):
+                    transaction.commit()
+                    datafile = open(imported_path,"a")
+                    writer = csv.DictWriter(datafile,
+                                            csv_keys,
+                                            extrasaction='ignore')
+                    writer.writerows(imported)
+                    datafile.close()
+                    total_added_to_imported += len(imported)
+                    imported = []
+                if len(pending) > 0:
+                    datafile = open(pending_tmp,"a")
+                    writer = csv.DictWriter(datafile,
+                                            csv_keys,
+                                            extrasaction='ignore')
+                    writer.writerows(pending)
+                    datafile.close()
+                    total_pending += len(pending)
+                    #total_added_to_pending += len(pending)
+                    pending = []
+                if not finished:
+                    msg = '%(commit_after)d imports committed of total %(total_added_to_imported)d\n' % vars()
+                    logger.info(msg)
+        elapse = time.time() - elapse
+        copy2(pending_tmp,pending_path)
+        msg = "Finished importing in %(mode)s mode from %(import_source_fn)s in %(elapse)6.2f seconds: " % vars()
+        msg += "read = %(count)d; %(imported_fn)s: added = %(total_added_to_imported)d; " % vars()
+        if pending_only:
+            removed_pending = pending_at_start - total_pending
+            msg += "%(pending_fn)s: removed = %(removed_pending)d, " % vars()
+        else:
+            added_pending = total_pending - pending_at_start 
+            msg += "%(pending_fn)s: added = %(added_pending)d, already in = %(already_in)s " % vars()
+        msg += ", total %(total_pending)d; " % vars()
+        logger.info(msg)
+        return msg
+    ###)
+
+    def d1402_importData(self,filename,name,edit=False,bypass_queue_catalog=False): ###(
         """load data from CSV values"""
         import transaction
